// Style CSS → [[Mediawiki:Common.css]] ↓
// ID #userSummaryButtons
// Autor: [[User:Beau]]

var pt$times = {
	"godzina"	: "1 hour",
	"2 godziny"	: "2 hours",
	"dzień "	: "1 day",
	"3 dni "	: "3 days",
	"tydzień"	: "1 week",
	"2 tygodnie"	: "2 weeks",
	"miesiąc"	: "1 month",
	"na zawsze"	: "infinite"
};

var pt$reasons = {
	"wandalizm"	: "częste wandalizmy",
	"wygłupy"	: "wygłupy",
	"spam"	: "spam",
	"wojna"		: "wojna edycyjna",
	"nieency"	: "nieencyklopedyczne wpisy"
};

var pt$levels = new Array(
	'edit', 'move', 'create'
);

function pt$expiry()
{
	this.select.value = this.title;
	if (this.select.id == 'mwProtectExpirySelection-edit') {
		var mwProtectUnchained = document.getElementById('mwProtectUnchained');
		var mwProtectExpirySelection_move = document.getElementById('mwProtectExpirySelection-move');
		if (mwProtectUnchained && !mwProtectUnchained.checked && mwProtectExpirySelection_move) {
			mwProtectExpirySelection_move.value = this.title;
		}
	}
}

function pt$init()
{
	for (var i = 0; i < pt$levels.length; i++) {
		var level = pt$levels[i];
		var select = document.getElementById('mwProtectExpirySelection-' + level);
		if (!select)
			continue;
		
		var td = select.parentNode;
	
		td.id = 'userSummaryButtons';
		
		for (var caption in pt$times)
		{
			var newButton = document.createElement('a');
			// atrybuty
			newButton.title = pt$times[caption];
			newButton.select = select;
			newButton.onclick = pt$expiry;
			newButton.appendChild(document.createTextNode(caption));
	
			// dodanie przycisku
			td.appendChild(newButton);
		}
	}
	
	var select = document.getElementById('wpProtectReasonSelection');
	if (select) {
		var reason = document.getElementById('mwProtect-reason');
		var td = select.parentNode;
	
		td.id = 'userSummaryButtons';
		
		for (var caption in pt$reasons)
		{
			var newButton = document.createElement('a');
	
			// atrybuty
			newButton.title = pt$reasons[caption];
			newButton.onclick = function() { reason.value = this.title; };
			newButton.appendChild(document.createTextNode(caption));
	
			// dodanie przycisku
			td.appendChild(newButton);
		}
	}
}

addOnloadHook(function()
{
	if (wgAction == 'protect' || wgAction == 'unprotect')
		pt$init();
});