// Style CSS → [[Mediawiki:Common.css]] ↓
// ID #userSummaryButtons

if (typeof(beau$callAPI) == 'undefined')
	importScript('MediaWiki:Gadget-lib-beau.js');

var del$loadingLinks = '<b>Wczytywanie linkujących...</b>';
var del$loadingHistory = '<b>Wczytywanie historii zmian...</b>';

var del$noLinks = '<span style="color: green; font-size: larger; font-weight:bold">Brak linkujących</span>';
var del$linksRedirect = 'strona przekierowująca';
var del$linksEmbedded = 'dołączony szablon';

var del$linksHeader = 'Linkujące <span style="font-size: x-small;">(pierwsze $1)</span>';
var del$historyHeader =  'Historia i autorzy <span style="font-size: x-small;">(ostatnie $1)</span>';

var del$showAllCaption = 'pokaż wszystkie';

var del$talkNamespace = /(?:talk$|^dyskusja)/i;

var del$redirect = /#(?:REDIRECT|PRZEKIERUJ|TAM)/i;
var del$speedy = /\{\{(?:ek|delete|speedy)\|(?:1=)?(.+?)(?:\}\}|$)/i;

var del$speedyCaption = "z eka";
var del$speedyReason = "z eka: $1";

// ---------------------------------------------------------
// Ustawienia domyślne - przycisków
// ---------------------------------------------------------

if (!del_buttons)
{
	var del_buttons = new Array(
		"general",	// identyfikator grupy (nie zmieniać i nie dodawać)
		"",		// etykieta
		new Array (	// przyciski
		    "nieency",	// etykieta
		    "wpis został uznany za [[Wikipedia:Encyklopedyczność|nieencyklopedyczny]]",	//wstawiany tekst
		    "substub",
		    "wpis został usunięty z powodu [[Pomoc:Jak napisać dobrą definicję|zbyt małej ilości treści]] - substub",
		    "eksperyment",
		    "wpis został uznany za eksperyment edycyjny - patrz: [[Wikipedia:Pierwsze kroki|pierwsze kroki]]",
		    "bełkot",
		    "wpis usunięty z powodu [[Wikipedia:Wandalizm|niezrozumiałej treści]]",
		    "wulgaryzmy",
		    "wpis usunięty z powodu umieszczonych w nim [[Wikipedia:Wandalizm|wulgaryzmów]]",
		    "wygłup",
		    "wpis usunięty - [[Wikipedia:Wandalizm|wygłup]]",
		    "reklama",
		    "wpis uznany za [[spam|reklamę]]",
		    "npa",
		    "wpis usunięty z powodu [[WP:PA|naruszenia praw autorskich]]",
		    "forma",
		    "wpis usunięto z powodu [[Wikipedia:Tworzenie haseł|nieodpowiedniej formy]]",
		    "zbędne",
		    "artykuł zbędny",
		    "nazwa",
		    "nieprawidłowa nazwa"
		),
		"talk",
		"dyskusja",
		new Array (
		    "bugbot",
		    "szablon [[user:Bugbot|bugbota]]",
		    "forum",
		    "strona dyskusji to nie forum",
		    "problem",
		    "na Wikipedii nie zajmujemy się rozwiązywaniem problemów",
		    "stare",
		    "stare",
		    "sierotka",
		    "sierotka",
		    "odpowiedziano",
		    "odpowiedziano na stronie dyskusji użytkownika",
		    "załatwione",
		    "załatwione"
		),
		"img",
		"plik",
		new Array (
		    "przeniesiono",
		    "przeniesiono do repozytorium mediów [[Wikimedia Commons]]",
		    "npa",
		    "plik usunięty z powodu [[WP:PA|naruszenia praw autorskich]]",
		    "licencja",
		    "plik bez określonej licencji",
		    "licencja-bd",
		    "brak danych do licencji - patrz [[Wikipedia:Opisy licencji grafiki]]",
		    "nazwa",
		    "nieinformatywna nazwa pliku - patrz [[Wikipedia:Zasady przesyłania plików|zasady]]",
		    "zbędne",
		    "zbędny/nieużywany plik",
		    "dubel",
		    "dubel"
		),
		"redir",
		"przekierowanie",
		new Array (
		    "zbędne",
		    "zbędne [[Pomoc:Przekierowanie|przekierowanie]]",
		    "zerwane",
		    "zerwane [[Pomoc:Przekierowanie|przekierowanie]]",
		    "błędne",
		    "błędne [[Pomoc:Przekierowanie|przekierowanie]]"
		),
		"tech",
		"porządki",
		new Array (
		    "sdu",
		    "usunięto, [[Wikipedia:SDU/" + wgPageName + "|wynik głosowania na SDU]] ",
		    "sdu24",
		    "usunięto, [[Wikipedia:SDU/" + wgPageName + "|wynik głosowania na SDU]], tryb 24h",
		    "poczekalnia",
		    "usunięto, decyzja z [[Wikipedia:Strony do usunięcia/Poczekalnia|Poczekalni SDU]]",
		    "pusta kategoria",
		    "pusta [[Wikipedia:Kategorie|kategoria]]",
		    "dubel",
		    "dubel"
		)
	);
}

var br$hideLink = 'Ukrywaj rewerty edycji tego użytkownika';
var br$hideWarning = 'Rewerty edycji tego użytkownika będą ukryte - pamiętaj aby robić to w zgodzie z <a href="' + wgArticlePath.replace('$1', 'Wikipedia:Narz%C4%99dzia_administracji#Ukrywanie_wandalizmu_z_ostatnich_zmian') +'">zasadami</a>!';

// ---------------------------------------------------------
// Ustawienia domyślne - linkujące oraz historia
// ---------------------------------------------------------

// maksymalna ilość pobieranych linkujących, 0 - nie pobiera
if (typeof(del_max_links) == 'undefined')
	del_max_links = 10;
	
// maksymalna ilość pobieranych wpisów z historii, 0 - nie pobiera
if (typeof(del_max_versions) == 'undefined')
	del_max_versions = 5;

// czy włączony jest tryb hardcode?
if (typeof(del_hardcore) == 'undefined')
	del_hardcore = false;

// czy włączone jest podświetlanie linku do strony dyskusji
if (typeof(del_talk_highlight) == 'undefined')
	del_talk_highlight = true;

// ---------------------------------------------------------
// Fragment kodu z LiveRC
// *Documentation : [[:fr:User:EDUCA33E/LiveRC/Documentation]]
// *Authors : [[:fr:User:EDUCA33E]], [[:fr:User:TiChou]] & [[:pl:User:Leafnode]]
// ---------------------------------------------------------

var wpajax = {
	http: function(bundle) {
		// mandatory: bundle.url
		// optional:  bundle.async
		// optional:  bundle.method
		// optional:  bundle.headers
		// optional:  bundle.data
		// optional:  bundle.onSuccess (xmlhttprequest, bundle)
		// optional:  bundle.onFailure (xmlhttprequest, bundle)
		// optional:  bundle.otherStuff OK too, passed to onSuccess and onFailure
		var xmlhttp;
		try {
			xmlhttp = new XMLHttpRequest();
		} catch(e) {
			try {
				xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
			} catch (e) {
				try {
					xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				} catch (e) {
					xmlhttp = false
				}
			}
		}

		if (xmlhttp) {
			xmlhttp.onreadystatechange = function() {
				if (xmlhttp.readyState == 4)
				wpajax.httpComplete(xmlhttp,bundle);
			};
			xmlhttp.open(bundle.method ? bundle.method : "GET",bundle.url,bundle.async == false ? false : true);
			if (bundle.headers) {
				for (var field in bundle.headers)
					xmlhttp.setRequestHeader(field,bundle.headers[field]);
			}
			xmlhttp.send(bundle.data ? bundle.data : null);
		}
		return xmlhttp;
	},

	httpComplete: function(xmlhttp,bundle) {
		if (xmlhttp.status == 200 || xmlhttp.status == 302) {
			if (bundle.onSuccess)
				bundle.onSuccess(xmlhttp,bundle);
		} else if (bundle.onFailure) {
			bundle.onFailure(xmlhttp,bundle);
		} else {
			// A activer en debug mode ?
			// alert(xmlhttp.statusText);
		}
	}
};

// Parser
if (document.implementation.createDocument) {
	var gml_xmlparser = new DOMParser();
}

function gml_XMLParse(string) {
	if (document.implementation.createDocument) {
		return gml_xmlparser.parseFromString(string, "text/xml");
	} else if (window.ActiveXObject) {
		var gml_xmldoc = new ActiveXObject("Microsoft.XMLDOM");
		gml_xmldoc.async = "false";
		ret = gml_xmldoc.loadXML(string);
		if (!ret)
			return null;
		return gml_xmldoc.documentElement;
	}
	return null;
}

// ---------------------------------------------------------

function del$gotHist(xmlreq, data)
{
	var doc = gml_XMLParse(xmlreq.responseText);

	var history_content = document.getElementById( 'history_content' );
	history_content.innerHTML = '';

	var mw_history_compare = doc.getElementById('mw-history-compare');
	if (mw_history_compare)
		history_content.appendChild(doc.getElementById('mw-history-compare'));	
}

function del_gotLinks(data)
{
	var links_content = document.getElementById( 'links_content' );

	var pages = new Array();
	
	for (var id in data.query.embeddedin) {
		var page = data.query.embeddedin[id];
		page.embedded = true;
		pages.push( page );
	}

	for (var id in data.query.backlinks) {
		var page = data.query.backlinks[id];
		pages.push( page );
	}	

	del$addLinks(links_content, pages);
}

function del_gotImageUsage(data)
{
	var links_content = document.getElementById( 'links_content' );

	var pages = new Array();
	
	for (var id in data.query.imageusage) {
		var page = data.query.imageusage[id];
		pages.push( page );
	}

	del$addLinks(links_content, pages);
}

function del$addLinks(container, list)
{
	if (list.length > 0) {
		var ul = document.createElement('ul');
		var limit = list.length;

		if (limit > del_max_links) 
			limit = del_max_links;

		for (var i = 0; i < limit; i++) {
			var page = list[i];
			var li = document.createElement('li');
			var link = document.createElement('a');
			link.title = page.title;
			link.href = wgScript + "?title=" + encodeURIComponent(page.title);
			link.appendChild( document.createTextNode(page.title) );	
			li.appendChild(link);
			var sufix = new Array();
			
			if (typeof(page.redirect) != 'undefined')
				sufix.push(del$linksRedirect);

			if (page.embedded)
				sufix.push(del$linksEmbedded);
			
			if (sufix.length)
				li.appendChild( document.createTextNode(" (" + sufix.join(', ') + ")"));

			ul.appendChild(li);
		}
		container.innerHTML = '';
		container.appendChild(ul);
		return;
	}

	container.innerHTML = del$noLinks;
}

function del$createButtons(parentNode, buttonArray)
{
	for (var j = 0; j < buttonArray.length; j+=2)
	{
		var newButton = document.createElement('a');

		// atrybuty
		newButton.title = buttonArray[j+1];
		newButton.onclick = function() { del$insertReason(this.title) };
		newButton.appendChild(document.createTextNode(buttonArray[j]));

		// dodanie przycisku
		parentNode.appendChild(newButton);
	}
}

function del$createGroup(id, caption, buttonArray)
{
	tr = document.createElement('tr');
	tr.id = "del_" + id;

	td_caption = document.createElement('td');
	td_caption.align = 'right';
	td_caption.appendChild( document.createTextNode(caption) );
	tr.appendChild(td_caption);
	
	td_buttons = document.createElement('td');
	td_buttons.align = 'left';
	td_buttons.id = 'userSummaryButtons';
	del$createButtons(td_buttons, buttonArray);
	tr.appendChild(td_buttons);
	
	return tr;
}

function del$showAll()
{
	for (var i = 0; i < del_buttons.length; i+=3)
	{
		var group = del_buttons[i];
		document.getElementById("del_" + group).style.display = '';
	}
	document.getElementById("del_general").cells[0].style.visibility = 'hidden';
}

function del$init() {
	var current_group = '';
	var defaultReason = '';
	var catalk = document.getElementById('ca-talk');
	if ( del_talk_highlight && catalk && catalk.className == '') {
		catalk.style.textDecoration = 'blink';
		catalk.firstChild.style.backgroundColor = 'orange';
	}
	var wpReason = document.getElementById('wpReason');
	if ( wpReason ) {
		wpReason.parentNode.align = "left";
		wpReason.style.width = "100%";
		defaultReason = wpReason.value;
		wpReason.value = '';
	}
	var tr_watch;
	
	if (wgNamespaceNumber == 6 && !document.getElementById('wpConfirmB'))
	{
		current_group = 'img';
		var mwfiledeletesubmit = document.getElementById('mw-filedelete-submit');
		tr_watch = mwfiledeletesubmit.parentNode.parentNode;
	}
	else
	{
		var wpWatch = document.getElementById('wpWatch');
		tr_watch = wpWatch.parentNode.parentNode;
	}
	var table= tr_watch.parentNode;
	
	if (defaultReason.match( del$redirect ))
	{
		current_group = 'redir';
	}
	else if (wgCanonicalNamespace.match( del$talkNamespace ) )
	{
		current_group = 'talk';
	}
	else if (wgNamespaceNumber == 14)
	{
		current_group = 'tech';
	}
	else if (wgNamespaceNumber == 6)
	{
		current_group = 'img';
	}
	else if (defaultReason.match(/\{\{(?:Pocz)?SDU/i))
	{
		current_group = 'tech';
	}

	for (var i = 0; i < del_buttons.length; i+=3)
	{
		var group = del_buttons[i];
		var caption = del_buttons[i+1];
		var buttons = del_buttons[i+2];
 	
		var new_tr = del$createGroup(group, caption, buttons);

		if (group == 'general')
		{
			var newButton = document.createElement('a');
		
			// atrybuty
			newButton.appendChild(document.createTextNode(del$showAllCaption));
			newButton.onclick = del$showAll;
			newButton.style.cursor = 'pointer';
		
			// dodanie przycisku
			new_tr.firstChild.appendChild(newButton);
		}
		else if (group == current_group)
		{
			new_tr.firstChild.style.fontWeight = 'bold';
		}
		else
		{
			new_tr.style.display = 'none';
		}
		table.insertBefore(new_tr, tr_watch);
	}

	var speedy_found = defaultReason.match( del$speedy );

	if (speedy_found)
	{
		var newButton = document.createElement('a');
	
		// atrybuty
		newButton.appendChild(document.createTextNode(del$speedyCaption));
		newButton.title = del$speedyReason.replace('$1', speedy_found[1]);
		newButton.onclick = function () { del$insertReason(this.title) };

		// dodanie przycisku
		document.getElementById('del_general').lastChild.appendChild(newButton);
	}

	var bodyContent = document.getElementById('bodyContent');
	var deletionlog = document.getElementById('mw-article-delete-deletionlog');
	
	if (del_max_versions > 0)
	{
		var history_header = document.createElement('h2');
		history_header.innerHTML = del$historyHeader.replace('$1', del_max_versions);
		bodyContent.insertBefore(history_header, deletionlog);

		var history_content = document.createElement('div');
		history_content.id = 'history_content';
		history_content.innerHTML = del$loadingHistory;
		
		bodyContent.insertBefore(history_content, deletionlog);

		wpajax.http({url:wgServer + wgScript + '?limit=' + del_max_versions + '&title=' + encodeURIComponent(wgPageName) + '&action=history', onSuccess: del$gotHist, message: wgPageName });
	}

	if (del_max_links > 0)
	{
		var links_header = document.createElement('h2');
		links_header.innerHTML = del$linksHeader.replace('$1', del_max_links);
		
		bodyContent.insertBefore(links_header, deletionlog);

		var links_content = document.createElement('div');
		links_content.id = 'links_content';
		links_content.innerHTML = del$loadingLinks;
		
		bodyContent.insertBefore(links_content, deletionlog);

		if (wgNamespaceNumber == 6) // file
			beau$callAPI({
				action:	'query',
				list:	'imageusage',
				iulimit:	del_max_links,
				iutitle:	wgPageName,
				callback:	'del_gotImageUsage'
			});
		else
			beau$callAPI({
				action:	'query',
				list:	'backlinks|embeddedin',
				bllimit:	del_max_links,
				bltitle:	wgPageName,
				eilimit:	del_max_links,
				eititle:	wgPageName,
				callback:	'del_gotLinks'
			});
	}
}

function del$insertReason(reason)
{
	var element = document.getElementById('wpReason');

	element.value = reason;

	if (del_hardcore)
	{
		element.form.submit();
	}
}

function br$init() {
	var div = document.getElementById('contentSub');
	if (!div)
		return;

	var url = new String(document.location);
	var img = document.createElement('img');
	img.src = 'http://upload.wikimedia.org/wikipedia/commons/thumb/8/81/Icon_tools.png/30px-Icon_tools.png';

	div.appendChild(document.createElement('br'));
	div.appendChild(img);
	div.appendChild(document.createTextNode(' '));

	if (url.match(/[?&]bot=1/)) {
		var span = document.createElement('span');
		span.innerHTML = br$hideWarning;
		span.style.cssText = 'color:red; font-weight: bold';
		div.appendChild(span);
	}
	else {
		var a = document.createElement('a');
		a.innerHTML = br$hideLink;
		a.href = url.match('\\?') ? url + "&bot=1" : url + "?bot=1";
		a.style.cssText = 'font-weight: bold';
		div.appendChild(a);
	}
}

addOnloadHook(function()
{
	// jeżeli to nie jest strona 'Usuń' zakończ działanie
	if (wgAction == "delete" && wgArticleId != 0)
		del$init();

	else if (wgCanonicalSpecialPageName == 'Contributions')
		br$init();
});