// Style CSS → [[Mediawiki:Common.css]] ↓
// ID #userSummaryButtons
// Autor: [[User:Beau]]

var bk$times = {
	"2 godziny"	: "2 hours",
	"4 godziny"	: "4 hours",
        "6 godzin"	: "6 hours",
	"dzień "	: "1 day",
	"3 dni "	: "3 days",
	"tydzień"	: "1 week",
	"2 tygodnie"	: "2 weeks",
	"miesiąc"	: "1 month",
	"na zawsze"	: "infinite"
};

var bk$reasons = {
	"wandal"	: "[[WP:W|wandalizm]]",
	"blanking"	: "[[WP:W|kasowanie zawartości artykułów (blanking)]]",
	"wygłupy"	: "[[WP:W|wygłupy]]",
	"wulg"	: "[[WP:W|wulgaryzmy]]",
	"npa"	: "[[WP:PA|łamanie praw autorskich]]",
	"spam"	: "[[WP:LZ|nagminne dodawanie linków zewnętrznych (spam)]]",
	"ency"	: "[[WP:ENCY|nagminne dodawanie nieencyklopedycznych wpisów]]",
	"wer"	: "[[WP:WER|nagminne dodawanie informacji niepopartych źródłami]]",
	"ataki"		: "[[WP:WE|ataki osobiste]]",
	"hoax"		: "[[WP:W|wprowadzanie fałszywych informacji (hoaxy)]]",
	"konto"		: "[[WP:W|konto stworzone do wandalizmów]]",
	"nazwa"		: "[[WP:NU|nazwa użytkownika niezgodna z zasadami Wikipedii]]",
	"pacynka"		: "[[WP:PAC|niedozwolone użycie pacynki]]",
};

function bk$setExpiry(wpBlockExpiry, wpBlockOther, value) {
	var listed = false;
	for (var i = 0; i < wpBlockExpiry.options.length; i++) {
		if (wpBlockExpiry.options[i].value == value) {
			listed = true;
		}
	}
	if (listed) {
		wpBlockExpiry.value = value;
		if (wpBlockExpiry.onchange)
			wpBlockExpiry.onchange(wpBlockExpiry);
	}
	else {
		wpBlockExpiry.value = 'other'
		wpBlockOther.value = value;
	}
}

function bk$init()
{
	var wpBlockExpiry = document.getElementById('wpBlockExpiry');
	var wpBlockOther = document.getElementById('mw-bi-other');
	
	var td = wpBlockExpiry.parentNode;

	td.appendChild(document.createElement('br'));
	td.id = 'userSummaryButtons';

	for (var caption in bk$times)
	{
		var newButton = document.createElement('a');
		
		// atrybuty
		newButton.title = bk$times[caption];
		newButton.onclick = function() { bk$setExpiry(wpBlockExpiry, wpBlockOther, this.title); };
		newButton.appendChild(document.createTextNode(caption));

		// dodanie przycisku
		td.appendChild(newButton);
	}

	var wpBlockReasonList = document.getElementById('wpBlockReasonList');
	var wpBlockOtherReason = document.getElementById('mw-bi-reason');
	
	var td = wpBlockReasonList.parentNode;

	td.appendChild(document.createElement('br'));
	td.id = 'userSummaryButtons';
	
	for (var caption in bk$reasons)
	{
		var newButton = document.createElement('a');

		// atrybuty
		newButton.title = bk$reasons[caption];
		newButton.onclick = function() { bk$setExpiry(wpBlockReasonList, wpBlockOtherReason, this.title); };
		newButton.appendChild(document.createTextNode(caption));

		// dodanie przycisku
		td.appendChild(newButton);
	}
}

addOnloadHook(function()
{
	if (wgCanonicalSpecialPageName == 'Blockip')
		bk$init();
});