// Skrypty dla użytkowników z uprawnieniami sysopa
// Opis: Realizowanie funkcjonalności przy pomocy JavaScriptu, aby nie przeładowywać strony.

function UndeleteInvertSelection() {
	var inputs = this.form.getElementsByTagName('input');
	for (var i = inputs.length-1; i>=0; i--)
		if (inputs[i].type=='checkbox')
			inputs[i].checked = !inputs[i].checked;
	
	return false;
}

if (wgCanonicalSpecialPageName == "Undelete")
{
	addOnloadHook(function()
	{
		var el = returnObjById('mw-undelete-invert');
		if (el)
			el.onclick = UndeleteInvertSelection;
	});
}

// Opis: Dodanie linka do sprawdzania adresu IP w ripe.net
if (wgCanonicalSpecialPageName == "Blockip")
{
	addOnloadHook(function()
	{
		var el = returnObjById('mw-bi-target');
		if (el)
		{
			if (!isNaN(parseInt(el.value)))
			{
			    var newEl = document.createElement('a');
			    var newAttr = document.createAttribute('target');
			    newAttr.nodeValue = '_blank'
			    newEl.setAttributeNode(newAttr);
			    newAttr = document.createAttribute('href');
			    newAttr.nodeValue = 'http://www.ripe.net/whois?form_type=simple&full_query_string=&searchtext='+el.value+'&do_search=Search'
			    newEl.setAttributeNode(newAttr);
			    newEl.appendChild(document.createTextNode(' sprawdź IP!'));
			    el.parentNode.insertBefore(newEl, el.nextSibling);
			}
		}
	});
}