/* generated javascript */
var skin = 'standard';
var stylepath = 'http://upload.wikimedia.org/skins';

/* MediaWiki:Common.js */
/*
UWAGA! Ten JavaScript działa dla wszystkich skórek. Należy zachować szczególną ostrożność wprowadzając tutaj zmiany!

'''Wyłączenie poszczególnych możliwości/skryptów'''
* Oznaczanie artykułów medalowych (dla interwiki)
 window.LinkFADone = true;
* Przesunięcie linków [ edytuj ] przy sekcjach
 var oldEditsectionLinks=true;
* Poprawka tytułu przy "Ograniczeniach technicznych"
 disableRealTitle = true;
*/
function returnObjById( id )
{ 
	if (document.getElementById)
		var returnVar = document.getElementById(id);
	else if (document.all)
		var returnVar = document.all[id];
	else if (document.layers)
		var returnVar = document.layers[id];
	return returnVar;
}

switch (skin)
{
	case "standard":
		var skinBC = 'article';
		break;
	case "cologneblue":
	case "nostalgia":
		var skinBC = 'content';
		break;
	case "modern":
		var skinBC = 'mw_content';
		break;
	case "chick":
	case "monobook":
	case "simple":
	default:
		var skinBC = 'bodyContent';
}
var bodyContent = returnObjById(skinBC);

/*
== Przesunięcie linków [ edytuj ] przy sekcjach ==
; Autor: Copyright 2006, Marc Mongenet
; Opis: Wyszukuje &lt;span class="editsection"> i przesuwa na koniec ich rodzica (nagłówka sekcji) wyświetlając ''inline'' ze zmniejszoną czcionką.
; Licencja: 
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

http://www.gnu.org/licenses/gpl.html
*/
addOnloadHook(function() {
 try {
	if (!(typeof oldEditsectionLinks == 'undefined' || oldEditsectionLinks == false)) return;
	var spans = document.getElementsByTagName("span");
	for (var s = 0; s < spans.length; ++s) {
		var span = spans[s];
		if (span.className == "editsection") {
			span.style.cssText = 'float:none; font-size:x-small; font-weight: normal;';
			span.parentNode.appendChild(document.createTextNode(" "));
			span.parentNode.appendChild(span);
		}
	}
 } catch (e) { /* błąd */ }
});


/** Interwiki links to featured articles ***************************************
 *
 *  Description: Highlights interwiki links to featured articles (or
 *               equivalents) by changing the bullet before the interwiki link
 *               into a star.
 *  Maintainers: [[User:R. Koot]]
 */

function LinkFA() 
{
	if ( window.LinkFADone )
		return;
	
	if ( document.getElementById( "p-lang" ) ) {
		var InterwikiLinks = document.getElementById( "p-lang" ).getElementsByTagName( "li" );
	
		for ( var i = 0; i < InterwikiLinks.length; i++ ) {
			if ( document.getElementById( InterwikiLinks[i].className + "-fa" ) ) {
				InterwikiLinks[i].className += " FA"
				InterwikiLinks[i].title = "Artykuł w tym języku jest na medal";
			}
		}
	}
	
	window.LinkFADone = true;
}
addOnloadHook( LinkFA );

/*
== Image page translation (PL) ==
; Author: Maciej Jaros [[:pl:User:Nux]]
; Licence: [http://opensource.org/licenses/gpl-license.php GNU General Public License v2]
*/
if (wgNamespaceNumber == 6 && wgUserLanguage == "pl")	// Image:
{
	addOnloadHook(plImagePageTranslation);
}

function plImagePageTranslation()
{
	var el = returnObjById('fileinfotpl_desc')
	if (el)
	{
		// Description
		el.innerHTML = 'Opis';
		// Source
		el = returnObjById('fileinfotpl_src');
		el.innerHTML = 'Źródło';
		el = el.parentNode.getElementsByTagName('TD')[0];
		el.innerHTML = el.innerHTML.replace(/<p>own work<\/p>/i, 'własna praca')
		// Date
		returnObjById('fileinfotpl_date').innerHTML = 'Data';
		// Author
		returnObjById('fileinfotpl_aut').innerHTML  = 'Autor';
		// Permission
		el = returnObjById('fileinfotpl_perm');
		el.innerHTML = 'Warunki udostępnienia';
		el = el.parentNode.getElementsByTagName('TD')[0];
		el.innerHTML = el.innerHTML.replace(/<p>see below<\/p>/i, 'zobacz poniżej')
		// Other versions
		el = returnObjById('fileinfotpl_ver')
		if (el) el.innerHTML  = 'Inne wersje';
		
		//
		// Common section headers translation
		var els = returnObjById(skinBC).getElementsByTagName('H2');
		for (var i=0; i<els.length; i++)
		{
			for (var j=0; j<els[i].childNodes.length; j++)
			{
				if (els[i].childNodes.item(j).className && els[i].childNodes.item(j).className=='mw-headline')
				{
					var cur = els[i].childNodes.item(j);
					switch (cur.innerHTML)
					{
						case 'Summary':
							cur.innerHTML = 'Konspekt';
						break;
						case 'Licensing':
							cur.innerHTML = 'Licencja';
						break;
						case 'Full description':
						case 'Description':
							cur.innerHTML = 'Pełny opis';
						break;
					}
				}
			}
		}
	}
}

 /* Test if an element has a certain class **************************************
  *
  * Description: Uses regular expressions and caching for better performance.
  * Maintainers: [[User:Mike Dillon]], [[User:R. Koot]], [[User:SG]]
  */
 
 var hasClass = (function () {
     var reCache = {};
     return function (element, className) {
         return (reCache[className] ? reCache[className] : (reCache[className] = new RegExp("(?:\\s|^)" + className + "(?:\\s|$)"))).test(element.className);
     };
 })();

/** Collapsible tables *********************************************************
  *
  *  Description: Allows tables to be collapsed, showing only the header. See
  *               [[en:Wikipedia:NavFrame]].
  *  Maintainers: [[User:R. Koot]]
  */

var autoCollapse = 2;
var collapseCaption = "ukryj";
var expandCaption = "pokaż";

function collapseTable( tableIndex )
{
    var Button = document.getElementById( "collapseButton" + tableIndex );
    var Table = document.getElementById( "collapsibleTable" + tableIndex );

    if ( !Table || !Button ) {
        return false;
    }

    var Rows = Table.rows;

    if ( Button.firstChild.data == collapseCaption ) {
        for ( var i = 1; i < Rows.length; i++ ) {
            Rows[i].style.display = "none";
        }
        Button.firstChild.data = expandCaption;
    } else {
        for ( var i = 1; i < Rows.length; i++ ) {
            Rows[i].style.display = Rows[0].style.display;
        }
        Button.firstChild.data = collapseCaption;
    }
}

function createCollapseButtons()
{
    var tableIndex = 0;
    var NavigationBoxes = new Object();
    var Tables = document.getElementsByTagName( "table" );

    for ( var i = 0; i < Tables.length; i++ ) {
        if ( hasClass( Tables[i], "collapsible" ) ) {

            /* only add button and increment count if there is a header row to work with */
            var HeaderRow = Tables[i].getElementsByTagName( "tr" )[0];
            if (!HeaderRow) continue;
            var Header = HeaderRow.getElementsByTagName( "th" )[0];
            if (!Header) continue;

            NavigationBoxes[ tableIndex ] = Tables[i];
            Tables[i].setAttribute( "id", "collapsibleTable" + tableIndex );

            var Button     = document.createElement( "span" );
            var ButtonLink = document.createElement( "a" );
            var ButtonText = document.createTextNode( collapseCaption );

            Button.style.styleFloat = "right";
            Button.style.cssFloat = "right";
            Button.style.fontWeight = "normal";
            Button.style.textAlign = "right";
            Button.style.width = "6em";

            ButtonLink.style.color = Header.style.color;
            ButtonLink.setAttribute( "id", "collapseButton" + tableIndex );
            ButtonLink.setAttribute( "href", "javascript:collapseTable(" + tableIndex + ");" );
            ButtonLink.appendChild( ButtonText );

            Button.appendChild( document.createTextNode( "[" ) );
            Button.appendChild( ButtonLink );
            Button.appendChild( document.createTextNode( "]" ) );

            Header.insertBefore( Button, Header.childNodes[0] );
            tableIndex++;
        }
    }

    for ( var i = 0;  i < tableIndex; i++ ) {
        if ( hasClass( NavigationBoxes[i], "collapsed" ) || ( tableIndex >= autoCollapse && hasClass( NavigationBoxes[i], "autocollapse" ) ) ) {
            collapseTable( i );
        } 
        else if ( hasClass( NavigationBoxes[i], "innercollapse" ) ) {
            var element = NavigationBoxes[i];
            while (element = element.parentNode) {
                if ( hasClass( element, "outercollapse" ) ) {
                    collapseTable ( i );
                    break;
                }
            }
        }
    }
}

addOnloadHook( createCollapseButtons );


/** Dynamic Navigation Bars (experimental) *************************************
 *
 *  Description: See [[Wikipedia:NavFrame]].
 *  Maintainers: UNMAINTAINED
 */

// set up the words in your language
var NavigationBarHide = '[' + collapseCaption + ']';
var NavigationBarShow = '[' + expandCaption + ']';

// shows and hides content and picture (if available) of navigation bars
// Parameters:
//     indexNavigationBar: the index of navigation bar to be toggled
function toggleNavigationBar(indexNavigationBar)
{
    var NavToggle = document.getElementById("NavToggle" + indexNavigationBar);
    var NavFrame = document.getElementById("NavFrame" + indexNavigationBar);

    if (!NavFrame || !NavToggle) {
        return false;
    }

    // if shown now
    if (NavToggle.firstChild.data == NavigationBarHide) {
        for (var NavChild = NavFrame.firstChild; NavChild != null; NavChild = NavChild.nextSibling) {
            if ( hasClass( NavChild, 'NavPic' ) ) {
                NavChild.style.display = 'none';
            }
            if ( hasClass( NavChild, 'NavContent') ) {
                NavChild.style.display = 'none';
            }
        }
    NavToggle.firstChild.data = NavigationBarShow;

    // if hidden now
    } else if (NavToggle.firstChild.data == NavigationBarShow) {
        for (var NavChild = NavFrame.firstChild; NavChild != null; NavChild = NavChild.nextSibling) {
            if (hasClass(NavChild, 'NavPic')) {
                NavChild.style.display = 'block';
            }
            if (hasClass(NavChild, 'NavContent')) {
                NavChild.style.display = 'block';
            }
        }
        NavToggle.firstChild.data = NavigationBarHide;
    }
}

// adds show/hide-button to navigation bars
function createNavigationBarToggleButton()
{
    var indexNavigationBar = 0;
    // iterate over all < div >-elements 
    var divs = document.getElementsByTagName("div");
    for (var i = 0; NavFrame = divs[i]; i++) {
        // if found a navigation bar
        if (hasClass(NavFrame, "NavFrame")) {

            indexNavigationBar++;
            var NavToggle = document.createElement("a");
            NavToggle.className = 'NavToggle';
            NavToggle.setAttribute('id', 'NavToggle' + indexNavigationBar);
            NavToggle.setAttribute('href', 'javascript:toggleNavigationBar(' + indexNavigationBar + ');');

            var isCollapsed = hasClass( NavFrame, "collapsed" );
            /*
             * Check if any children are already hidden.  This loop is here for backwards compatibility:
             * the old way of making NavFrames start out collapsed was to manually add style="display:none"
             * to all the NavPic/NavContent elements.  Since this was bad for accessibility (no way to make
             * the content visible without JavaScript support), the new recommended way is to add the class
             * "collapsed" to the NavFrame itself, just like with collapsible tables.
             */
            for (var NavChild = NavFrame.firstChild; NavChild != null && !isCollapsed; NavChild = NavChild.nextSibling) {
                if ( hasClass( NavChild, 'NavPic' ) || hasClass( NavChild, 'NavContent' ) ) {
                    if ( NavChild.style.display == 'none' ) {
                        isCollapsed = true;
                    }
                }
            }
            if (isCollapsed) {
                for (var NavChild = NavFrame.firstChild; NavChild != null; NavChild = NavChild.nextSibling) {
                    if ( hasClass( NavChild, 'NavPic' ) || hasClass( NavChild, 'NavContent' ) ) {
                        NavChild.style.display = 'none';
                    }
                }
            }
            var NavToggleText = document.createTextNode(isCollapsed ? NavigationBarShow : NavigationBarHide);
            NavToggle.appendChild(NavToggleText);

            // Find the NavHead and attach the toggle link (Must be this complicated because Moz's firstChild handling is borked)
            for(var j=0; j < NavFrame.childNodes.length; j++) {
                if (hasClass(NavFrame.childNodes[j], "NavHead")) {
                    NavFrame.childNodes[j].appendChild(NavToggle);
                }
            }
            NavFrame.setAttribute('id', 'NavFrame' + indexNavigationBar);
        }
    }
}

addOnloadHook( createNavigationBarToggleButton );

/**
 * Skrypt dla Szablon:Galeria
 */
function toggleImage(group, remindex, shwindex) {
  returnObjById("ImageGroupsGr"+group+"Im"+remindex).style.display="none";
  returnObjById("ImageGroupsGr"+group+"Im"+shwindex).style.display="inline";
}
function ImageGroup(){
  if (document.URL.match(/printable/g)) return;
  var divs=document.getElementsByTagName("div");
  var i = 0, j = 0;
  var units, search;
  var currentimage;
  var UnitNode;
  for (i = 0; i < divs.length ; i++) {
    if (divs[i].className != "ImageGroup") continue;
    UnitNode=undefined;
    search=divs[i].getElementsByTagName("div");
    for (j = 0; j < search.length ; j++) {
      if (search[j].className != "ImageGroupUnits") continue;
      UnitNode=search[j];
      break;
    }
    if (UnitNode==undefined) continue;
    units=Array();
    for (j = 0 ; j < UnitNode.childNodes.length ; j++ ) {
      var temp = UnitNode.childNodes[j];
      if (temp.className=="center") units.push(temp);
    }
    for (j = 0 ; j < units.length ; j++) {
      currentimage=units[j];
      currentimage.id="ImageGroupsGr"+i+"Im"+j;
      var imghead = document.createElement("div");
      var leftlink = document.createElement("a");
      var rightlink = document.createElement("a");
      if (j != 0) {
        leftlink.href = "javascript:toggleImage("+i+","+j+","+(j-1)+");";
        leftlink.innerHTML="◀";
      }
      if (j != units.length - 1) {
        rightlink.href = "javascript:toggleImage("+i+","+j+","+(j+1)+");";
        rightlink.innerHTML="▶";
      }
      var comment = document.createElement("tt");
      comment.innerHTML = "("+ (j+1) + "/" + units.length + ")";
      with(imghead) {
        style.fontSize="110%";
        style.fontweight="bold";
        appendChild(leftlink);
        appendChild(comment);
        appendChild(rightlink);
      }
      if (units.length>1) currentimage.insertBefore(imghead,currentimage.childNodes[0]);
      if (j != 0) currentimage.style.display="none";
    }
  }
}
addOnloadHook(ImageGroup);

 /** Main Page layout fixes *********************************************************
  *
  *  Description:        Various layout fixes for the main page, including an
  *                      additional link to the complete list of languages available
  *                      and the renaming of the 'Article' to to 'Main Page'.
  *  Maintainers:        [[User:AzaToth]], [[User:R. Koot]]
  */
 
function mainPageRenameNamespaceTab() {
	try {
		var Node = document.getElementById( 'ca-nstab-main' ).firstChild;
		if ( Node.textContent ) {      // Per DOM Level 3
			Node.textContent = 'Strona główna';
		} else if ( Node.innerText ) { // IE doesn't handle .textContent
			Node.innerText = 'Strona główna';
		} else {                       // Fallback
			Node.replaceChild( Node.firstChild, document.createTextNode( 'Strona główna' ) );
		}
	} catch(e) {
		// bailing out!
	}
}

function mainPageAppendCompleteListLink() {
	try {
		var node = document.getElementById( "p-lang" )
			.getElementsByTagName('div')[0]
			.getElementsByTagName('ul')[0];
	
		var aNode = document.createElement( 'a' );
		var liNode = document.createElement( 'li' );
	
		aNode.appendChild( document.createTextNode( 'Kompletna lista' ) );
		aNode.setAttribute( 'href' , wgArticlePath.replace('$1', 'Wikipedia:Kompletna_lista_j%C4%99zyk%C3%B3w') );
		liNode.appendChild( aNode );
		liNode.className = 'interwiki-completelist';
		node.appendChild( liNode );
	} catch(e) {
		// lets just ignore what's happened
		return;
	}
}
 
if ( wgTitle == 'Strona główna' && ( wgNamespaceNumber == 0 || wgNamespaceNumber == 1 ) ) {
	addOnloadHook( mainPageRenameNamespaceTab );
}

if ( wgTitle == 'Strona główna' && wgNamespaceNumber == 0 ) {
	addOnloadHook( mainPageAppendCompleteListLink );
}


/*
  Poprawka funkcji tabelkowych
*/
function ts_parseFloat(num) {
	if (!num) return 0;
	num = parseFloat(num.replace(/,/g, ".").replace(/[\xa0]/g, ""));
	return (isNaN(num) ? 0 : num);
}

// Correctly handle PNG transparency in Win IE 5.5 & 6.
// http://homepage.ntlworld.com/bobosola. Updated 18-Jan-2006.
// 
// Tweaked 10 Sep 2007 (UTC) by Remember_the_dot so that it works properly inside Common.js
// http://homepage.ntlworld.com/bobosola/pnginfo.htm states "This page contains more information for the curious or those who wish to amend the script for special needs", which I take as permission to modify or adapt this script freely. I release my changes into the public domain.

function PngFix()
{
   if (document.body.filters)
   {
       for(var i=0; i<document.images.length; i++)
       {
          var img = document.images[i]
          var imgName = img.src.toUpperCase()
          if (imgName.substring(imgName.length-3, imgName.length) == "PNG")
          {
             var imgID = (img.id) ? "id='" + img.id + "' " : ""
             var imgClass = (img.className) ? "class='" + img.className + "' " : ""
             var imgTitle = (img.title) ? "title='" + img.title + "' " : "title='" + img.alt + "' "
             var imgStyle = "display:inline-block; vertical-align:middle;" + img.style.cssText 
             if (img.align == "left") imgStyle = "float:left;" + imgStyle
             if (img.align == "right") imgStyle = "float:right;" + imgStyle
             if (img.parentElement.href) imgStyle = "cursor:hand;" + imgStyle
             var strNewHTML = "<span " + imgID + imgClass + imgTitle
             + " style=\"font-size:0; display:inline-block;" + imgStyle + "\"><span style=\'width:" + img.width + "; height:" + img.height + "; display:inline-block; filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
             + "(src=\"" + img.src + "\', sizingMethod='image');\"></span></span>" 
             img.outerHTML = strNewHTML
             i = i-1
          }
       }
   }
}
 
if (navigator.appName == "Microsoft Internet Explorer")
{
	var version = parseFloat(navigator.appVersion.split("MSIE")[1])
	if (version <= 6 && version >= 5.5)
	{
		window.addOnloadHook(PngFix)
	}
}


/////////////////////////////////////////
/////       Skrypty zewnętrzne     //////
/////////////////////////////////////////


// Importowanie funkcji działających podczas edycji. Patrz: [[MediaWiki:Common-edit.js]]

if (wgAction == 'edit' || wgAction == 'submit')
{
	if (wgCanonicalNamespace != "Special")
	{
		importScript( "MediaWiki:Common-edit.js" )
	}
}

// Poprawka tytułu przy "Ograniczeniach technicznych". Patrz: [[MediaWiki:RealTitleBanner.js]].
// var disableRealTitle = 0; -> ustawienie tego na 1 lub true w swoim monobook.js pozwoli wyłączyć tę funkcjonalność

importScript( "MediaWiki:RealTitleBanner.js" )

//  Importowanie skryptów tylko dla anomimowych użytkowników. Patrz: [[MediaWiki:OnlyForAnonims.js]]
if (wgUserGroups == null)
	importScript( "MediaWiki:Common-Anon.js" );

var isSysop = false;
if (wgUserGroups != null)
	for (var i = 0; i < wgUserGroups.length; i++)
		if (wgUserGroups[i] == 'sysop') {
			isSysop = true;
			break;
		}

if ( isSysop )
{
	// Importowanie skryptów tylko dla administratorów. Patrz: [[MediaWiki:OnlyForAdmins.js]]
	importScript( "MediaWiki:Common-Sysop.js" )
}
else
{
	// Dla osób nie będących administratorami
	// Popup do zgłaszania błędów. Patrz: [[MediaWiki:Wikibugs.js]]
	importScript( "MediaWiki:Wikibugs.js" )
}

// Skrypty na stronie przesyłania plików
if (wgCanonicalSpecialPageName == 'Upload')
	importScript("MediaWiki:Common-Upload.js");
// Skrypty na stronie wyszukiwania
else if (wgCanonicalSpecialPageName == 'Search')
	importScript("MediaWiki:Common-Search.js");
// Pobieranie styli CSS dla [[Wikipedia:CommonsTicker]]
else if ( wgPageName == "Wikipedia:CommonsTicker" )
	importStylesheet( "MediaWiki:CommonsTicker.css" );

/** WikiMiniAtlas *******************************************************
  *
  *  Description: WikiMiniAtlas is a popup click and drag world map.
  *               This script causes all of our coordinate links to display the WikiMiniAtlas popup button.
  *               The script itself is located on meta because it is used by many projects.
  *               See [[Meta:WikiMiniAtlas]] for more information. 
  *  Maintainers: [[User:Dschwen]]
  */

if (wgServer == "https://secure.wikimedia.org") {
	var metaBase = "https://secure.wikimedia.org/wikipedia/meta";
} else {
	var metaBase = "http://meta.wikimedia.org";
}
importScriptURI(metaBase+"/w/index.php?title=MediaWiki:Wikiminiatlas.js&action=raw&ctype=text/javascript&smaxage=21600&maxage=86400");

var wma_settings =
{
	height : 400,
	width : 700
}

/*
== Drobne skrypty ==
; Author: Maciej Jaros [[:pl:User:Nux]]
; License: Public domain
*/
//
// Zaznacza wszystkie elementy typu "checkbox" na stronie - wywołanie javascript:ZaznaczWszystkie()
//
function ZaznaczWszystkie()
{
	var inpt = document.getElementsByTagName('input');
	for (var i=inpt.length-1; i>=0; i--)
		if (inpt[i].type=='checkbox')
			inpt[i].checked=true;
}
//
// RSS kategorii
//
if (wgNamespaceNumber == 14)
{
	addOnloadHook(function()
	{
		var ptb = document.getElementById('p-tb');
		if (!ptb)
			return;

		var top = ptb.getElementsByTagName('ul')[0];

		var nli = document.createElement('li');
		nli.id = 't-katrss';

		var na = document.createElement('a');
		na.title = 'RSS kategorii '+wgTitle;
		var rsslink = 'http://toolserver.org/~cspurrier/rss/rss.php'
			+'?lang=pl&family=wikipedia'
			+'&desc=RSS%20kategorii%20Wikipedii'
			+'&title='+encodeURIComponent(wgTitle)
			+'&categories='+encodeURIComponent(wgTitle);
		na.setAttribute('href', rsslink);
		na.appendChild(document.createTextNode('RSS kategorii'));

		nli.appendChild(na);
		top.appendChild(nli);
	});
}
//
// Array.indexOf() dla kompatybilności różnych skryptów z IE
// (skrypt z Mozilli)
if (!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function(elt /*, from*/)
	{
		var len = this.length;

		var from = Number(arguments[1]) || 0;
		from = (from < 0) ? Math.ceil(from) : Math.floor(from);
		if (from < 0)
			from += len;

		for (; from < len; from++)
		{
			if (from in this && this[from] === elt)
				return from;
		}
		return -1;
	};
}
//
// Ustawienie wysokości "Usunięcie" pustego elementu contentSub
//
addOnloadHook(function()
{
	var el=document.getElementById('mw-revisiontag');
	if (el && el.className.indexOf('flaggedrevs_short')!=-1)
	{
		if (el.parentNode.id=='contentSub') el.parentNode.style.height='17px';
	}
});

/* MediaWiki:Standard.js */
/* Any JavaScript here will be loaded for users using the Standard skin */